#!/usr/bin/env zsh

set -e

run() {
  echo $1
  #for i in 4096 8192 16384 32768 65536 131072 262144 524288 1048576 2097152 4194304 8388608 16777216 33554432; do
  for i in 4096 8192; do
    ./sort $i 20000 1
  done
  for i in 16384 32768 65536; do
    ./sort $i 2000 5
  done
  for i in 131072 262144 524288; do
    ./sort $i 200 50
  done
  for i in 1048576 2097152 4194304; do
    ./sort $i 20 500
  done
  for i in 8388608 16777216 33554432; do
    ./sort $i 2 5000
  done
}

bench() {
  g++ ${=2} -fprofile-generate -fpermissive --std=c++0x -O3 -o sort sort.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
  g++ ${=2} -fprofile-use -fpermissive --std=c++0x -O3 -o sort sort.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
}

#bench "sort afterwards" "-DSMALL=64 -DBUFFER_SIZE=500 -DBASE=nothing -DSORT_AFTERWARDS -DSORTER=insertionSort"
#bench "buffered, insertionSort, combined" "-DBUFFER_COMBINE -DONE_BUFFER -DSMALL=64 -DBUFFER_SIZE=4 -DBASE=buffered -DSORTER=insertionSort"

#bench "ssss, afterwards" "-DSORT_AFTERWARDS -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=nothing -DBASE=mine2 -DSORTER=insertionSort"
#bench "ssss, afterwards" "-DSORT_AFTERWARDS -DSSSS -DSSMALL=128 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=nothing -DBASE=mine2 -DSORTER=insertionSort"
#bench "std::sort"      "-DSTDSORT -DSMALL=64 -DBUFFER_SIZE=500 -DBASE=sort -DSORTER=smallSort"

#bench "insertionSort" "-DSMALL=64 -DBUFFER_SIZE=500 -DBASE=insertionSort -DSORTER=smallSort"
#bench "ssss with std::sort" "-DSSSS -DSSMALL=4096 -DBUFFER_SIZE=500 -DSBASE=sort -DSORTER=smallSort"
#bench "ssss with insertionSort" "-DSSSS -DSSMALL=64 -DBUFFER_SIZE=500 -DSBASE=insertionSort -DSORTER=smallSort"
bench "ssss with qsort" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=qsort2 -DBASE=nothing -DSORTER=insertionSort"
#bench "ssss without basecase" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=nothing -DBASE=nothing -DSORTER=insertionSort"
