#!/usr/bin/env zsh

set -e

run() {
  echo $1
  #for i in 33554432; do
  #for i in 128 256 512 1024 2048 4096; do
  #for i in 128 256 512 1024 2048 4096 8192 16384 32768 65536 131072 262144 524288 1048576 2097152 4194304 8388608; do
  #for i in 32768 65536 131072 262144 524288 1048576 2097152 4194304 8388608; do

  #for i in 128 256 512; do
  #  ./sort $i 100000 1
  #done
  for i in 1024 2048 4096; do
    ./sort $i 100000 1
  done
  #for i in 8192 16384 32768; do
  #  ./sort $i 10000 10
  #done
  #for i in 65536 131072 262144; do
  #  ./sort $i 1000 100
  #done
  #for i in 524288 1048576 2097152; do
  #  ./sort $i 100 1000
  #done
  #for i in 4194304 8388608; do
  #  ./sort $i 10 10000
  #done
  #for i in 16777216 33554432 67108864 134217728; do
  #  ./sort $i 1 100000
  #done
}

bench() {
  g++ ${=2} -fprofile-generate -fpermissive --std=c++0x -O3 -o sort sort.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
  g++ ${=2} -fprofile-use -fpermissive --std=c++0x -O3 -o sort sort.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
}

bench "insertionSort" "-DSMALL=64 -DBUFFER_SIZE=500 -DBASE=insertionSort -DSORTER=smallSort"
bench "buffered, insertionSort, combined" "-DBUFFER_COMBINE -DONE_BUFFER -DSMALL=64 -DBUFFER_SIZE=4 -DBASE=buffered -DSORTER=insertionSort"
bench "sort afterwards" "-DSMALL=64 -DBUFFER_SIZE=500 -DBASE=nothing -DSORT_AFTERWARDS -DSORTER=insertionSort"
#bench "newbuffered, insertionSort, combined" "-DBUFFER_COMBINE -DONE_BUFFER -DSMALL=64 -DBUFFER_SIZE=4 -DBASE=newbuffered -DSORTER=insertionSort"
