#!/usr/bin/env zsh

set -e

RUNS=100000

run() {
  echo $1
  for i in 128 256; do
    ./sort $i 1000000 1
  done
  for i in 512 1024; do
    ./sort $i 100000 1
  done
  for i in 2048 4096 8192; do
    ./sort $i 10000 10
  done
  for i in 16384 32768 65536; do
    ./sort $i 1000 100
  done
  for i in 131072 262144 524288; do
    ./sort $i 100 1000
  done
}

bench() {
  g++ ${=2} -fprofile-generate -fpermissive --std=c++0x -O3 -o sort sort.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
  g++ ${=2} -fprofile-use -fpermissive --std=c++0x -O3 -o sort sort.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
}

#bench "std::sort"      "-DSTDSORT -DSMALL=64 -DBUFFER_SIZE=500 -DBASE=sort -DSORTER=smallSort"
bench "quicksort with std::sort" "-DSMALL=128 -DBUFFER_SIZE=500 -DBASE=sort -DSORTER=smallSort"
#bench "insertionSort" "-DSMALL=64 -DBUFFER_SIZE=500 -DBASE=insertionSort -DSORTER=smallSort"
#bench "sort afterwards" "-DSMALL=64 -DBUFFER_SIZE=500 -DBASE=nothing -DSORT_AFTERWARDS -DSORTER=insertionSort"
#bench "buffered, insertionSort, combined" "-DBUFFER_COMBINE -DONE_BUFFER -DSMALL=64 -DBUFFER_SIZE=4 -DBASE=buffered -DSORTER=insertionSort"
