#!/usr/bin/env zsh

set -e

run() {
  echo $1
  #for i in 33554432; do
  #for i in 128 256 512 1024 2048 4096; do
  #for i in 128 256 512 1024 2048 4096 8192 16384 32768 65536 131072 262144 524288 1048576 2097152 4194304 8388608; do
  #for i in 32768 65536 131072 262144 524288 1048576 2097152 4194304 8388608; do

  #for i in 128 256 512; do
  #  ./sort $i 100000 1
  #done
  #for i in 1024 2048 4096; do
  #  ./sort $i 10000 10
  #done
  #for i in 8192 16384 32768; do
  #  ./sort $i 1000 100
  #done
  #for i in 65536 131072 262144; do
  #  ./sort $i 100 1000
  #done
  #for i in 524288 1048576 2097152; do
  #  ./sort $i 10 10000
  #done
  for i in 4194304 8388608 16777216 33554432; do
    ./sort $i 1 100000
  done
}

bench() {
  g++ ${=2} -fprofile-generate -fpermissive --std=c++0x -O3 -o sort sort.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1 >/dev/null
  g++ ${=2} -fprofile-use -fpermissive --std=c++0x -O3 -o sort sort.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
}

#bench "ssss with std::sort" "-DSSSS -DSMALL=4096 -DBUFFER_SIZE=500 -DBASE=sort -DSORTER=smallSort"
#bench "ssss with std::sort" "-DSSSS -DSMALL=2048 -DSSMALL=2048 -DBUFFER_SIZE=500 -DSBASE=sort -DSORTER=smallSort"
##bench "ssss, smallSort" "-DSSSS -DSMALL=64 -DBUFFER_SIZE=500 -DBASE=smallSort -DSORTER=smallSort"
##bench "ssss, buffered smallSort" "-DSSSS -DSMALL=64 -DBUFFER_SIZE=500 -DBASE=buffered -DSORTER=smallSort"
##bench "ssss, buffered combined smallSort" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSMALL=64 -DBUFFER_SIZE=500 -DBASE=buffered -DSORTER=smallSort"
##bench "ssss, sorted buffered smallSort" "-DSSSS -DONE_BUFFER -DBUFFER_COMBINE -DBUFFER_SORT -DSMALL=64 -DBUFFER_SIZE=500 -DBASE=buffered -DSORTER=smallSort"
##bench "ssss, mixed" "-DSSSS -DSMALL=64 -DBUFFER_SIZE=500 -DBASE=mine -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSMALL=4096 -DBUFFER_SIZE=5000 -DBASE=mine -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSSMALL=2048 -DBUFFER_SIZE=10000 -DSMALL=64 -DSBASE=mine -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSMALL=2048 -DBUFFER_SIZE=10000 -DBASE=nothing -DSORT_AFTERWARDS -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSMALL=4096 -DBUFFER_SIZE=10000 -DBASE=nothing -DSORT_AFTERWARDS -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSMALL=8192 -DBUFFER_SIZE=10000 -DBASE=nothing -DSORT_AFTERWARDS -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSSMALL=2048 -DBUFFER_SIZE=500 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSSMALL=4096 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSSMALL=1024 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
##bench "ssss, mixed" "-DONE_BUFFER -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
#bench "ssss, mixed" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
##bench "ssss, mixed" "-DBUFFER_SORT -DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
##bench "ssss, mixed" "-DSSSS -DSSMALL=1024 -DBUFFER_SIZE=5000 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=sort"

bench "ssss, mine2" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=8 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine2 -DSORTER=insertionSort"
bench "8ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=8 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "16ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=16 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "32ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=32 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "64ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=64 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "128ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=128 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "256ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=256 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "512ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=512 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "1024ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=1024 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "2048ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=2048 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
bench "4096ssss, mine" "-DONE_BUFFER -DBUFFER_COMBINE -DSSSS -DSSMALL=1024 -DBUFFER_SIZE=4096 -DSMALL=64 -DSBASE=qsort2 -DBASE=mine -DSORTER=insertionSort"
