#!/usr/bin/env zsh

set -e

RUNS=1000

run() {
  echo $1
  for i in 2 4 8; do
    ./verysmall $i 10000000 1
  done
  for i in 16 32 64; do
    ./verysmall $i 1000000 10
  done
  for i in 128 256; do
    ./verysmall $i 100000 100
  done
}

bench() {
  g++ ${=2} -fprofile-generate -fpermissive --std=c++0x -O3 -o verysmall verysmall.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
  g++ ${=2} -fprofile-use -fpermissive --std=c++0x -O3 -o verysmall verysmall.cpp mt-real.C measuretime.cpp 2>/dev/null
  run $1
}

#bench "shellSort" "-DSORTER=shellsort"
#bench "smallSort" "-DSORTER=smallSort"
bench "std::sort" "-DSORTER=sort"
bench "insertionSort" "-DSORTER=insertionSort"
bench "insertionSort2" "-DSORTER=insertionSort2"
bench "sortInsertion" "-DSORTER=sortInsertion"
bench "sort2Insertion" "-DSORTER=sort2Insertion"
