#ifndef LOG2_H
#define LOG2_H

#include <type_traits>


/** LOG2<N>::value returns log2(N) computed during compile time. It's only defined if N is a power of 2. */

template<int N, class Enable = void>
struct LOG2 {
    // no value defined
};

template<int N>
struct LOG2<N, typename std::enable_if<~N&1>::type >
{
    static const int value = LOG2<N/2>::value + 1;
};

template<>
struct LOG2<1>
{
    static const int value = 0;
};

#endif // LOG2_H
