#include "measuretime.h"
#include <sys/resource.h>
#include <sys/times.h>
#include <iostream>

Timer::Timer() : startTime(currentTime())
{
}

double Timer::elapsed() const
{
    return currentTime() - startTime;
}

double Timer::currentTime()
{
    struct rusage rusage;
    if(getrusage(RUSAGE_SELF, &rusage) != -1)
        return (double)rusage.ru_utime.tv_sec * 1000.0 +
               (double)rusage.ru_utime.tv_usec / 1000.0;
    //exit(1);
}

