#include <iostream>
#include <iomanip>
#include <algorithm>
#include <map>

#include "smallsort.h"
#include "measuretime.h"
#include "util.h"
#include "log2.h"
#include "findsamples.h"

using namespace std;

map<string, double> times;
#define TIME_BEGIN(timeVar) Timer timer_##timeVar
#define TIME_END(timeVar) times[#timeVar] += timer_##timeVar.elapsed()

//#define DETAILED_TIME_MEASUREMENT
#ifdef DETAILED_TIME_MEASUREMENT

#define MEASURETIME_BEGIN(timeVar) Timer timer_##timeVar
#define MEASURETIME_END(timeVar) times[#timeVar] += timer_##timeVar.elapsed()

#else
#define MEASURETIME_BEGIN(timeVar) void(0)
#define MEASURETIME_END(timeVar) void(0)
#endif

int main(int argc, char** argv) {
  int n = atoi(argv[1]);
  int repeat = atoi(argv[2]);
  int mult = atoi(argv[3]);
  //int seed = atoi(argv[3]);
  //sgenrand(seed);
  srand(0);

  int *a = new int[n];

  avgFactor = 8;
  KK = 5;
  initInc(KK);

  for (int r = 0; r < repeat; r++) {
    for (int i = 0; i < n;  i++) {
      //a[i] = int(1e9*genrand_double());
      a[i] = rand();
    }

    //printArray(a, n, "input");

    TIME_BEGIN(total);
    SORTER(a, a+n);
    TIME_END(total);
  }

#ifdef PRINT_RESULTS
  printArray(a, n, "sorted");
#endif

  for(auto j = times.begin(); j != times.end(); ++j)
  {
    double time = j->second;
    //cout << setw(8) << right << n << setw(8) << right << time / repeat << endl;
    //cout << setw(8) << right << n << setw(8) << right << time << endl;
    cout << setw(8) << right << n << setw(12) << right << (long long)(time * mult) << endl;
  }
}
